=== test/cpp/CMakeLists.txt ===
add_subdirectory(message_serialization)
add_subdirectory(common)
add_subdirectory(multidimarray)
add_subdirectory(robdef_test)
add_subdirectory(misc)
add_subdirectory(service)
