=== debian/changelog ===
robotraconteur (1.2.7-1) unstable; urgency=medium

  * Initial release. (Closes: #1110148)

 -- John Wason <wason@wasontech.com>  Sat, 06 Dec 2025 22:20:04 -0500
