=== debian/control ===
Source: robotraconteur
Section: libs
Priority: optional
Maintainer: John Wason <wason@wasontech.com>
Build-Depends: debhelper-compat (= 13),
               cmake,
               libbluetooth-dev,
               libboost-date-time-dev,
               libboost-filesystem-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libboost-regex-dev,
               libboost-chrono-dev,
               libboost-atomic-dev,
               libboost-random-dev,
               libboost-program-options-dev,
               libboost-dev,
               libdbus-1-dev,
               libssl-dev,
               libusb-1.0-0-dev,
               zlib1g-dev,
               python3-dev,
               python3-numpy,
               python3-setuptools,
               libgtest-dev,
               dh-sequence-python3,
               dh-sequence-numpy3
Standards-Version: 4.7.2
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/johnwason/robotraconteur
Vcs-Git: https://salsa.debian.org/johnwason/robotraconteur.git
Homepage: https://github.com/robotraconteur/robotraconteur

Package: librobotraconteurcore1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}, libbluetooth3, libdbus-1-3, libusb-1.0-0
Pre-Depends: ${misc:Pre-Depends}
Description: Robot Raconteur core runtime library
 Robot Raconteur is a communication framework for
 Robotics and Automation. This package provides the
 core runtime library of Robot Raconteur.

Package: librobotraconteur-dev
Architecture: any
Multi-Arch: no
Section: libdevel
Depends: librobotraconteurcore1 (= ${binary:Version}),
         robotraconteurgen,
         ${misc:Depends},
         libboost-date-time-dev,
         libboost-filesystem-dev,
         libboost-system-dev,
         libboost-thread-dev,
         libboost-regex-dev,
         libboost-chrono-dev,
         libboost-atomic-dev,
         libboost-random-dev,
         libboost-program-options-dev,
         libboost-dev
Description: Robot Raconteur development files
 Robot Raconteur is a communication framework for
 Robotics and Automation. This package provides the
 development files for Robot Raconteur

Package: python3-robotraconteur
Architecture: any
Multi-Arch: no
Section: python
Depends: ${misc:Depends}, ${shlibs:Depends}, libbluetooth3,
         libdbus-1-3, libusb-1.0-0,
         ${python3:Depends}
Description: Python module for Robot Raconteur
 Robot Raconteur is a communication framework for
 Robotics and Automation. This package provides the Robot
 Raconteur Python module.

Package: robotraconteurgen
Architecture: any
Multi-Arch: no
Section: devel
Depends: librobotraconteurcore1, ${misc:Depends}, ${shlibs:Depends}
Description: Robot Raconteur code generator
 Robot Raconteur is a communication framework for
 Robotics and Automation. This package provides the
 RobotRaconteurGen tool for generating thunk code from
 robdef files.
