=== debian/tests/control ===
Test-Command: python3 -c "import RobotRaconteur; print(RobotRaconteur)"
Depends: python3-robotraconteur, python3
