=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d[\d\.]*)\/RobotRaconteur-([\d\.]+)-Source\.tar\.gz/robotraconteur-$2.tar.gz/ \
https://github.com/robotraconteur/robotraconteur/tags .*/v([\d\.]+)
